/// <reference types="node" />
import { Data } from './types';
import { VirgilPublicKey } from './VirgilPublicKey';
export declare class VirgilStreamCipher {
    private _isFinished;
    private _isRunning;
    private _isDisposed;
    private readonly recipientCipher;
    private readonly messageInfoCustomParams?;
    private readonly aes256Gcm;
    get isRunning(): boolean;
    get isFinished(): boolean;
    get isDisposed(): boolean;
    constructor(arg0: VirgilPublicKey | VirgilPublicKey[], arg1?: Data);
    start(): Buffer;
    update(data: Data): Buffer;
    final(dispose?: boolean): Buffer;
    dispose(): void;
    private ensureLegalState;
    private ensureIsRunning;
}
